// Arvude aluste teisendaja


#include <stdio.h>

// abimuutuja
char letters[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

// teisenda - arvu aluste teisendamise funktsioon.
//
// sisend: algbase  - arvu algne alus
//         alg      - algne arv
//         l6ppbase - arvu l6plik alus
//         l6pp     - teisendatud arv. peab olema vhemalt char[65]
//                    tpi muutuja overflow takistamiseks.
//
// vljund: 0 - kik lks hsti
//          1 - esines mingisugune viga
int teisenda(int algbase, char *alg, int l6ppbase, char *l6pp)
{
	int t, i;
	long long result = 0;
	long long mult = 1;
	char temp[65];
	
	// vaatame, et arv oleks sobival alusel
	if(algbase < 2 || algbase > 36 || l6ppbase < 2 || l6ppbase > 36)
	{
		// kui ei ole, vljastame veateate
		return 1;
	}
	
	// kui alus ei muutu, kopeerime arvu mber
	if(algbase == l6ppbase)
	{
		t = strlen(alg);
		for(i=0;i<=t;i++) l6pp[i] = alg[i];
		return 0;
	}

	// teisendame kogu krempli kmnendssteemi, et arvu vimalikult
	// mugavalt mlus hoida. lisaks ei pea sedasi tehes looma algoritme
	// mistahes alusel olevate arvude jagamiseks ning jgi leidmiseks.
	t = strlen(alg);
	for(i=t-1;i>=0;i--)
	{
		t = (
			(alg[i] >= '0' && alg[i] <= '9') ? alg[i]-'0' :
			(alg[i] >= 'A' && alg[i] <= 'Z') ? alg[i]-'A'+10 :
			(alg[i] >= 'a' && alg[i] <= 'z') ? alg[i]-'a'+10 : -1
		);
		if(t == -1 || t >= algbase) return 1;
		
		result += mult * t;
		
		mult *= algbase;
	}

	// teisendame kmnendssteemis oleva arvu vastavale alusele.
	for(i=0;result>0;i++)
	{
		temp[i] = letters[result % l6ppbase];
		result /= l6ppbase;
	}
	for(t=0;t<i;t++)
	{
		l6pp[t] = temp[i-t-1];
	}
	l6pp[i] = '\0';
	
	if(i == 0) { l6pp[0] = '0'; l6pp[1] = '\0'; }
	
	// tagastame teate, et kik lks hsti.	
	return 0;
}



int main()// pea(meetodi)programmi algus
{
	char temp[65], arv[65];
	int a, b;
	
	printf("Palun sisestage: [algne arv] [algne alus] [lplik alus]\n");
	printf("Programmi t lpetamiseks sisestage alus 0.\n");
	
	do
	{
		scanf("%s %d %d", arv, &a, &b);
		if(teisenda(a, arv, b, temp) == 0)
		{
			printf("%s_%d = %s_%d\n",
				arv, a, temp, b);
		}
		else
		{
			printf("Esines viga!\n");
		}
	} while(a != 0 || b != 0);
	
	return 0;
}
